//% MACROECONOMIC EFFECTS OF A CREDIT DEEPENING (2013) %//

options_.noprint=0;

var 
wi lambdai Y ci li  
ye K  lambdae Be ce re qk phie 
x I  C rk  Bi spr_txj cre_pib crede credi Ca Ia phii si credsi Bsi qs Is credwi K_d li_d Cad;

var nu_I b_fut;

varexo taue taui tausi;

parameters sig bettap phi 
bettai gamma theta bettae delta kappa_pi kappa_y
infl_ss phip rho_rb epsilony 
Ye_1 Ye_2 d_lp d_k1 R_inflss epsl ind_w kappap kappai deltas kappasi sigma pp pi pe gammae etae rbb;

parameters chi_b chi_wl chi_Fb chi_Fwl;

load param.mat

sigma    = param(1);
sig      = param(2);
bettap   = param(3);
bettae   = param(4);
bettai   = param(5);
phi      = param(6);
gamma    = param(7);
theta    = param(8);
delta    = param(9);
kappai   = param(10);
kappa_pi = param(11);
kappa_y  = param(12);
infl_ss  = param(13);
phip     = param(14);
rho_rb   = param(15);
epsilony = param(16);
epsl     = param(17);
ind_w    = param(18);
kappap   = param(19);
deltas   = param(20);
kappasi  = param(21);
pp       = param(22);
pe       = param(23);
pi       = param(24);
etae     = param(25);
gammae   = param(26);
chi_b  = param(27);
chi_wl  = param(28);
chi_Fb  = param(29);
chi_Fwl = param(30);

Ye_1     = theta*(1-gamma);
Ye_2     = (1-theta)*(1-gamma);
d_lp     = (1-gamma)*theta;
d_k1     = bettae*gamma;
R_inflss = (infl_ss)^(1-phip);

rbb = 0.016880211511084;


model;

// IMPATIENT HOUSEHOLDS: 
//% 1.

sigma*ci^(-1) = lambdai;

//% 2.

(1-sigma)*si^(-1) - lambdai*qs + phii*tausi*qs(+1)*(1-deltas) + lambdai(+1)*bettai*qs(+1)*(1-deltas) = 0 ;

//% 3.

(li)^phi =  (lambdai)*(wi) + taui*chi_wl*(wi)*(phii) + (1/bettai)*chi_Fwl*(wi)*(nu_I(-1)); 

//% 4.

ci + (1+re(-1))*(Bi(-1)) + qs*si = (wi)*(li) + Bi  + qs*(1-deltas)*si(-1);

//% 5. 

(1+re)*Bi = taui*( chi_b*b_fut +  chi_wl*wi*li ) + tausi*qs(+1)*(1-deltas)*si;  

//% 6.

lambdai - phii  * (1+re) = bettai * lambdai(+1) * (1+re); 

//% C1 7


b_fut = chi_Fb*b_fut(+1) + chi_Fwl*wi(+1)*li(+1); // **** New equation ****

//% C2 8

nu_I = chi_b*taui*phii + (1/bettai)*chi_Fb*nu_I(-1);  // **** New equation ****

// ENTREPRENEURS: 
//% 9.

(ce)^(-1) = (lambdae);

//% 10. 

wi = Ye_2*ye/((li_d)*x);

//% 11.

lambdae - phie  * (1+re) = bettae * lambdae(+1) * (1+re); 

//% 12. 

(phie)  * taue * (qk(+1)) * (1-delta) 
     + bettae * (lambdae(+1)) * ( (qk(+1))*(1-delta) + (rk(+1))) = (lambdae) * (qk); 

//% 13.

ye = (K_d(-1))^(gamma)*(li_d)^(Ye_2); 

//% 14. 

rk = gamma *(K_d(-1))^(gamma-1)*(li_d)^(Ye_2)/x;

//% 15. 

(1+re) * Be = taue * qk(+1)  * K_d * (1-delta); 

//% CAPITAL PRODUCERS: 
//% 16.

K = (1-delta) * (K(-1)) + ( 1 - kappai/2 * ((I)/(I(-1)) - 1)^2 ) * (I) ; 

//% 17. 

1 = qk *  ( 1 -  kappai/2 * (I/(I(-1)) - 1)^2  - kappai * (I/(I(-1)) - 1) * (I)/(I(-1)) ) 
  + bettae*( (lambdae(+1))/(lambdae)*(qk(+1)) *   kappai * ((I(+1))/(I) - 1) * ((I(+1))/(I))^2 ) ;


//% PRODUCERS OF DURABLE GOODS: 

//% 18.

si = (1-deltas) * (si(-1)) + ( 1 - kappasi/2 * ((Is)/(Is(-1)) - 1)^2 ) * (Is) ; 

//% 19. 

1 = qs *  (1 -  kappasi/2 * (Is/(Is(-1)) - 1)^2  - kappasi * (Is/(Is(-1)) - 1) * (Is)/(Is(-1))) 
  + bettai*((lambdai(+1))/(lambdai)*(qs(+1)) *   kappasi * ((Is(+1))/(Is) - 1) * ((Is(+1))/(Is))^2) ;

// FINAL GOOD PRODUCERS: 

//% 20.

(1-epsilony)+epsilony/(x) = 0;

// BANKS: 
//% 21.

(1+re) = ( 1+ gammae*etae* (pe*Be+pi*Bi)^(gammae-1) )*(1+rbb); 

// MARKET CLEARING CONDITIONS:
//% 22.

Y = pe*ye; 

//% 23.

pi*li = pe*li_d; 


//% 24.

K = pe*K_d; 

//% 25.

C = pi*(ci) + pe*ce; // **** Modified ****

//% 26.

Y + (Bi - (1+re(-1))*Bi(-1)) + (Be - (1+re(-1))*Be(-1)) = C + I + Is + etae*(pe*Be+pi*Bi)^gammae; 

// RATIOS:
//% 27.

(spr_txj) = (re) - (rbb); 

//% 28.

(cre_pib) = (pe*Be + pi*Bi)/(Y);

//% 29.

crede = (pe*Be)/(Y);

//% 30.

credi = pi*Bi/Y;

//% 31.

Bsi = (1/(1+re))*tausi*qs(+1)*(1-deltas)*si;

//% 32.

credsi = pi*Bsi/Y;

//% 33.

Ca = (C)/Y;

//% 34.

Ia = (I+Is)/Y;

//% 35.

credwi = pi*(Bi - Bsi)/Y; 

//% 36.

Cad = ((pi*Bi - (1+re(-1))*pi*Bi(-1)) + (pe*Be - (1+re(-1))*pe*Be(-1)));

end;

load init

initval;

wi      = initvalue(6);
lambdai = initvalue(7);
Y       = initvalue(8);
ci      = initvalue(9);
li      = initvalue(11);
ye      = initvalue(12);
K       = initvalue(13);
lambdae = initvalue(14);
Be      = initvalue(15);
ce      = initvalue(16);
re      = initvalue(17);
qk      = initvalue(18);
phie    = initvalue(19);
x       = initvalue(20);
I       = initvalue(21);
C       = initvalue(22);
rk      = initvalue(23);
Bi      = initvalue(24);
spr_txj = initvalue(25);
cre_pib = initvalue(26);
crede   = initvalue(27);
credi   = initvalue(28);
Ca      = initvalue(29);
Ia      = initvalue(30);
phii    = initvalue(31);
si      = initvalue(32);
credsi  = initvalue(34);
Bsi     = initvalue(35);
qs      = initvalue(36);
Is      = initvalue(38);
credwi  = initvalue(39);

li_d    = (pi/pe)*initvalue(11);
K_d     = (1/pe)*initvalue(13);

taue    = initvalue(41);
taui    = initvalue(42);
tausi   = initvalue(43);

b_fut = initvalue(44); //initvalue(2)/(1+initvalue(10))*initvalue(6)*initvalue(11);

nu_I = initvalue(45); // initvalue(42)*initvalue(31);

end;

steady;
check;

load endv

endval;

wi      = endvalue(6);
lambdai = endvalue(7);
Y       = endvalue(8);
ci      = endvalue(9);
li      = endvalue(11);
ye      = endvalue(12);
K       = endvalue(13);
lambdae = endvalue(14);
Be      = endvalue(15);
ce      = endvalue(16);
re      = endvalue(17);
qk      = endvalue(18);
phie    = endvalue(19);
x       = endvalue(20);
I       = endvalue(21);
C       = endvalue(22);
rk      = endvalue(23);
Bi      = endvalue(24);
spr_txj = endvalue(25);
cre_pib = endvalue(26);
crede   = endvalue(27);
credi   = endvalue(28);
Ca      = endvalue(29);
Ia      = endvalue(30);
phii    = endvalue(31);
si      = endvalue(32);
credsi  = endvalue(34);
Bsi     = endvalue(35);
qs      = endvalue(36);
Is      = endvalue(38);
credwi  = endvalue(39);

li_d    = (pi/pe)*endvalue(11);
K_d     = (1/pe)*endvalue(13);

taue    = endvalue(41);
taui    = endvalue(42);
tausi   = endvalue(43);


b_fut = endvalue(44); // endvalue(2)/(1+endvalue(10))*endvalue(6)*endvalue(11);

nu_I = endvalue(45); // endvalue(42)*endvalue(31);

end;

steady;
check;

load pathe
load pathwi
load pathsi

shocks;

var taue;
periods 1:34;
values(pathe);

var taui;
periods 1:34;
values(pathwi);

var tausi;
periods 1:34;
values(pathsi);

end;



simul(periods=1000);

