//% MACROECONOMIC EFFECTS OF A CREDIT DEEPENING (2016) %//

options_.noprint=0;

var cp infl lambdap lp wp
wi lambdai Y ci rb li  
ye K re qk 
x I  C rk  Bi spr_txj cre_pib crede credi Ca Ia phii si sp credsi Bsi qs S Is credwi dp K_d lp_d li_d;

var nu_I b_fut;

varexo taui tausi;

parameters sig bettap phi 
bettai gamma theta bettae delta kappa_pi kappa_y
infl_ss phip rho_rb epsilony 
Ye_1 Ye_2 d_lp d_k1 R_inflss epsl ind_w kappap kappai deltas kappasi sigma pp pi pe gammae etae;

parameters chi_b chi_wl chi_Fb chi_Fwl;

load param.mat

sigma    = param(1);
sig      = param(2);
bettap   = param(3);
bettae   = param(4);
bettai   = param(5);
phi      = param(6);
gamma    = param(7);
theta    = param(8);
delta    = param(9);
kappai   = param(10);
kappa_pi = param(11);
kappa_y  = param(12);
infl_ss  = param(13);
phip     = param(14);
rho_rb   = param(15);
epsilony = param(16);
epsl     = param(17);
ind_w    = param(18);
kappap   = param(19);
deltas   = param(20);
kappasi  = param(21);
pp       = param(22);
pe       = param(23);
pi       = param(24);
etae     = param(25);
gammae   = param(26);
chi_b  = param(27);
chi_wl  = param(28);
chi_Fb  = param(29);
chi_Fwl = param(30);

Ye_1     = theta*(1-gamma);
Ye_2     = (1-theta)*(1-gamma);
d_lp     = (1-gamma)*theta;
d_k1     = bettae*gamma;
R_inflss = (infl_ss)^(1-phip);

model;

// PATIENT HOUSEHOLDS: 
//% 1.

sigma*(cp)^(-1) = lambdap;

//% 2.

(1 - sigma)*sp^(-1) + bettap*lambdap(+1)*qs(+1)*(1-deltas) = qs*lambdap;

//% 3. 

lambdap  = bettap * lambdap(+1) * (1+rb)/ infl(+1); 

//% 4.

lp = (lambdap*wp)^(1/(phi));

// IMPATIENT HOUSEHOLDS: 
//% 5.

sigma*ci^(-1) = lambdai;

//% 6.

(1-sigma)*si^(-1) - lambdai*qs + phii*tausi*qs(+1)*infl(+1)/(1+re)*(1-deltas) + lambdai(+1)*bettai*qs(+1)*(1-deltas) = 0 ;

//% 7.

(li)^(phi) =  (lambdai)*(wi) + taui*chi_wl*(wi)*(phii) + (1/bettai)*chi_Fwl*infl/(1+re(-1))*(wi)*(nu_I(-1)); 

//% 8.

ci + (1+re(-1))*(Bi(-1))/(infl) + qs*si = (wi)*(li) + Bi  + qs*(1-deltas)*si(-1);

//% 9. 

Bi = taui*( chi_b*b_fut +  chi_wl*wi*li ) + tausi*qs(+1)*infl(+1)/(1+re)*(1-deltas)*si;  
 
//% 10.

lambdai - phii = bettai * lambdai(+1) * (1+re) / (infl(+1));

//% C1

b_fut = chi_Fb*infl(+1)/(1+re)*b_fut(+1) + chi_Fwl*infl(+1)/(1+re)*wi(+1)*li(+1); // **** New equation ****

//% C2

nu_I = chi_b*taui*phii + (1/bettai)*chi_Fb*infl/(1+re(-1))*nu_I(-1);  // **** New equation ****

// ENTREPRENEURS (EXCLUDED): 
//% 11.

//% (ce)^(-1) = (lambdae);

//% 12. 

wp = (d_lp*ye)/((lp_d)*x);

//% 13. 

wi = Ye_2*ye/((li_d)*x);

//% 14.

//% lambdae - phie  * (1+re) = bettae * lambdae(+1) * (1+re) / (infl(+1)); 

//% 15. 

bettap * (lambdap(+1)) * ( (qk(+1))*(1-delta) + (rk(+1))) = (lambdap) * (qk); 

//% 16.

ye = (K_d(-1))^(gamma)*(lp_d)^(Ye_1)*(li_d)^(Ye_2); 

//% 17. 

rk = gamma *(K_d(-1))^(gamma-1)*(lp_d)^(Ye_1)*(li_d)^(Ye_2)/x;

//% 18. 

//% ce + ((1+re(-1)) * Be(-1)) / infl +  ((wp)*(lp_d) + (wi)*(li_d)) + (qk) * (K_d)=  (ye/x) 
//%    + (Be) + (qk) * (1-delta) * (K_d(-1)) ;  
 
//% 19. 

//% (1+re) * Be = taue * qk(+1)  * infl(+1) * K_d * (1-delta); 

//% CAPITAL PRODUCERS: 
//% 20.

K = (1-delta) * (K(-1)) + ( 1 - kappai/2 * ((I)/(I(-1)) - 1)^2 ) * (I) ; 

//% 21. 

1 = qk *  ( 1 -  kappai/2 * (I/(I(-1)) - 1)^2  - kappai * (I/(I(-1)) - 1) * (I)/(I(-1)) ) 
  + bettap*( (lambdap(+1))/(lambdap)*(qk(+1)) *   kappai * ((I(+1))/(I) - 1) * ((I(+1))/(I))^2 ) ;

//% PRODUCERS OF DURABLE GOODS: 
//% 22.

S =  pi*si + pp*sp;

//% 23.

S = (1-deltas) * (S(-1)) + ( 1 - kappasi/2 * ((Is)/(Is(-1)) - 1)^2 ) * (Is) ; 

//% 24. 

1 = qs *  (1 -  kappasi/2 * (Is/(Is(-1)) - 1)^2  - kappasi * (Is/(Is(-1)) - 1) * (Is)/(Is(-1))) 
  + bettap*((lambdap(+1))/(lambdap)*(qs(+1)) *   kappasi * ((Is(+1))/(Is) - 1) * ((Is(+1))/(Is))^2) ;

// FINAL GOOD PRODUCERS: 

//% 25.

(1-epsilony)+epsilony/(x)-kappap*((infl)-(infl(-1))^phip*R_inflss)*(infl)
    +bettap*kappap*((lambdap(+1))/(lambdap))*((infl(+1))-(infl)^phip*R_inflss)*(infl(+1))*(Y(+1))/(Y); // **** Modified ****

// BANKS: 
//% 26.

(1+re) = ( 1+ gammae*etae* (pi*Bi)^(gammae-1) )*(1+rb); 

//% 27.

pp*dp = (pi*Bi)*( 1 + gammae*etae* (pi*Bi)^(gammae-1) ); 

// TAYLOR RULE: 
//% 28.

(1 + rb) = (1+rb(-1))^(rho_rb)*(infl_ss/bettap)^(1-rho_rb)*(infl/infl_ss)^((kappa_pi)*(1-rho_rb))*((Y)/(Y(-1)))^((kappa_y)*(1-rho_rb));

// MARKET CLEARING CONDITIONS:
//% 29.

Y = pe*ye; 

//% 29.

pi*li = pe*li_d; 

//% 30.

pp*lp = pe*lp_d; 

//% 31.

K = pe*K_d; 

//% 32.

C = pi*(ci) + pp*(cp); // **** Modified ****

//% 33.

Y = C + I + Is + (kappap/2*((infl)-(infl(-1))^phip*R_inflss)^2)*(Y)+etae*(pi*Bi)^gammae; 

// RATIOS:
//% 34.

(spr_txj) = (re) - (rb); 

//% 35.

(cre_pib) = (pi*Bi)/(Y);

//% 36.

crede = 0;

//% 37.

credi = pi*Bi/Y;

//% 38.

Bsi = (1/(1+rb))*tausi*qs(+1)*infl(+1)*(1-deltas)*si;

//% 39.

credsi = pi*Bsi/Y;

//% 40.

Ca = (C)/Y;

//% 39.

Ia = (I+Is)/Y;

//% 41.

credwi = pi*(Bi - Bsi)/Y; 


end;

load init

initval;

cp      = initvalue(1);
infl    = initvalue(2);
lambdap = initvalue(3);
lp      = initvalue(4);
wp      = initvalue(5);
wi      = initvalue(6);
lambdai = initvalue(7);
Y       = initvalue(8);
ci      = initvalue(9);
rb      = initvalue(10);
li      = initvalue(11);
ye      = initvalue(12);
K       = initvalue(13);
re      = initvalue(17);
qk      = initvalue(18);
x       = initvalue(20);
I       = initvalue(21);
C       = initvalue(22);
rk      = initvalue(23);
Bi      = initvalue(24);
spr_txj = initvalue(25);
cre_pib = initvalue(26);
crede   = initvalue(27);
credi   = initvalue(28);
Ca      = initvalue(29);
Ia      = initvalue(30);
phii    = initvalue(31);
si      = initvalue(32);
sp      = initvalue(33);
credsi  = initvalue(34);
Bsi     = initvalue(35);
qs      = initvalue(36);
S       = initvalue(37);
Is      = initvalue(38);
credwi  = initvalue(39);
dp      = initvalue(40);

li_d    = (pi/pe)*initvalue(11);
lp_d    = (pp/pe)*initvalue(4);
K_d     = (1/pe)*initvalue(13);

taui    = initvalue(42);
tausi   = initvalue(43);

b_fut = initvalue(44); //initvalue(2)/(1+initvalue(10))*initvalue(6)*initvalue(11);

nu_I = initvalue(45); // initvalue(42)*initvalue(31);

end;

steady;
check;

load endv

endval;

cp      = endvalue(1);
infl    = endvalue(2);
lambdap = endvalue(3);
lp      = endvalue(4);
wp      = endvalue(5);
wi      = endvalue(6);
lambdai = endvalue(7);
Y       = endvalue(8);
ci      = endvalue(9);
rb      = endvalue(10);
li      = endvalue(11);
ye      = endvalue(12);
K       = endvalue(13);
re      = endvalue(17);
qk      = endvalue(18);
x       = endvalue(20);
I       = endvalue(21);
C       = endvalue(22);
rk      = endvalue(23);
Bi      = endvalue(24);
spr_txj = endvalue(25);
cre_pib = endvalue(26);
crede   = endvalue(27);
credi   = endvalue(28);
Ca      = endvalue(29);
Ia      = endvalue(30);
phii    = endvalue(31);
si      = endvalue(32);
sp      = endvalue(33);
credsi  = endvalue(34);
Bsi     = endvalue(35);
qs      = endvalue(36);
S       = endvalue(37);
Is      = endvalue(38);
credwi  = endvalue(39);
dp      = endvalue(40);

li_d    = (pi/pe)*endvalue(11);
lp_d    = (pp/pe)*endvalue(4);
K_d     = (1/pe)*endvalue(13);

taui    = endvalue(42);
tausi   = endvalue(43);


b_fut = endvalue(2)/(1+endvalue(10))*endvalue(6)*endvalue(11);

nu_I = endvalue(42)*endvalue(31);

end;

steady;
check;

load pathe
load pathwi
load pathsi

shocks;


var taui;
periods 1:34;
values(pathwi);

var tausi;
periods 1:34;
values(pathsi);

end;



simul(periods=1000);

