
% ****** Find Be ******

x1 = 0.1;
x2 = 0.9;
x_step = 0.01;
X = x1:x_step:x2;
F = calcErrorSS(X,isInit);
[minF , minX] = min(abs(F));
Be = X(minX);

for i = 1:7
x1 = Be-x_step;
x2 = Be+x_step;
x_step = x_step/100;
X = x1:x_step:x2;
F = calcErrorSS(X,isInit);
[minF , minX] = min(abs(F));
Be = X(minX);
end;

% ****** Set tau's ******

if isInit == true
load init;
taue    = initvalue(41);
taui    = initvalue(42);
tausi   = initvalue(43);
else
load endv
taue    = endvalue(41);
taui    = endvalue(42);
tausi   = endvalue(43);
end

% ****** Set parameters ******

load param.mat

sigma    = param(1);
sig      = param(2);
bettap   = param(3);
bettae   = param(4);
bettai   = param(5);
phi      = param(6);
gamma    = param(7);
theta    = param(8);
delta    = param(9);
kappai   = param(10);
kappa_pi = param(11);
kappa_y  = param(12);
infl_ss  = param(13);
phip     = param(14);
rho_rb   = param(15);
epsilony = param(16);
epsl     = param(17);
ind_w    = param(18);
kappap   = param(19);
deltas   = param(20);
kappasi  = param(21);
pp       = param(22);
pe       = param(23);
pi       = param(24);
etae     = param(25);
gammae   = param(26);
chi_b  = param(27);
chi_wl  = param(28);
chi_Fb  = param(29);
chi_Fwl = param(30);

   Ye_1     = theta*(1-gamma);
   Ye_2     = (1-theta)*(1-gamma);
   d_lp     = (1-gamma)*theta;
   d_k1     = bettae*gamma;
   R_inflss = (infl_ss)^(1-phip);

   re =  ( 1 + etae*gammae * (pe*Be)^(gammae-1) )*infl_ss/bettap - 1;

   G1 = (1-sigma) / ( 1 + bettap * (bettai/bettap - 1) * (1 - deltas) * tausi - (1-deltas)*bettai );
    
    G21 = 1 - taui * (1/bettap-1) * ( chi_b*chi_Fwl*bettap/(1-chi_Fb*bettap) + chi_wl );
    G22 = sigma/G1 + (1-bettap) * (1-deltas) * tausi + deltas;
    G2 = G21/G22;
    
    G3 = G1/G2 * chi_b * taui * (1 - bettai/bettap) / (1 - bettap*chi_Fb/bettai);
    
    G4 = (1-sigma)/(1 - bettap*(1-deltas));
    
    G5 = 1/bettae/gamma * (1 - ( infl_ss/(1+re) - bettae )*taue*(1-delta) - bettae*(1-delta));
    
    G6 = 1/G1*sigma*G2*G5*(1-theta)*(1-gamma);
    
% ****** Set other variables ******
    
    li = ( G1/G2 + chi_wl*taui*(1-bettai/bettap)*G1/G2 + bettap/bettai*chi_Fwl*G3 )^(1/(1+phi));
    
    G71 = 1 /G5 /pe * (epsilony-1) /epsilony * (pp^(theta*(1-gamma))) * (pi*li)^((1-gamma)*(1-theta)) * (G5*theta*(1-gamma)*G4)^(theta*(1-gamma)/(1+phi));
    G7 = G71^((1+phi)/theta/(1-gamma));
           
    K =  Be * ( 1 + etae*gammae*(pe*Be)^(gammae-1) ) /taue/bettap/(1-delta);
    
    ye =  G5*epsilony/(epsilony-1)*K;   
    
    Y =  pe*ye;
    
    ci =  G6*K;
           
    rb_ss = infl_ss/bettap-1;
    
    rb = rb_ss;
    
    ce =  G5*K - delta*K - ((1+re)/infl_ss - 1)*Be - theta*(1-gamma)*G5*K - (1-theta)*(1-gamma)*G5*K;
    
    cp =  sigma /G4 *G7 *K^(1 - (1+phi)/theta);
    
    C =  pi*ci + pe*ce + pp*cp;
    
    I =  delta*K;
    
    sp =  G7 *K^(1 - (1+phi)/theta);
    
    si =  G1*G6/sigma*K;
    
    Is =  deltas * (sp + si);
    
    lambdap = G4/sp;
    
    qw = (epsilony-1)/epsilony;
    
    x = 1/qw;
    
    lp = ( qw*ye/sp*theta*(1-gamma)*G4) ^(1/(1+phi));
    
    wp = sp*lp^phi/G4;
    
    wi = qw*ye*(1-theta)*(1-gamma)/li;
    
    lambdai = G1/si;
    
    lambdae = 1/ce;
    
    qk = 1;
    
    qs = 1;
    
    phii = lambdai*(1 - bettai/bettap);
    
    phie = lambdae * (  1/(1+re) - bettae/infl_ss );
    
    rk = gamma * (1/pe) *(K)^(gamma-1)*(pp*lp)^(Ye_1)*(pi*li)^(Ye_2)/x;

 b_fut = chi_Fwl*bettap*wi*li/(1-chi_Fb*bettap);

infl = infl_ss;

    Bi = taui*( chi_b*b_fut +  chi_wl*wi*li ) + tausi*qs*infl/(1+rb)*(1-deltas)*si;
    
    spr_txj = (re) - (rb); 

cre_pib = (Be + Bi)/(Y);
	

crede = (Be)/(Y);

credi = Bi/Y;

Bsi = (1/(1+rb))*tausi*qs*infl*(1-deltas)*si;

credsi = Bsi/Y;

Ca = (C)/Y;

Ia = (I+Is)/Y;

credwi = (Bi - Bsi)/Y; 

S = sp + si;

dp = (pi*Bi + pe*Be*( 1 + gammae*etae* (pe*Be)^(gammae-1) ))/pp;

nu_I = G3/wi/li;

% ****** Upload values ******
 if isInit ==true
 
 initvalue = zeros(45,1);
 
initvalue(1) =cp      ;  
initvalue(2) =infl    ;  
initvalue(3) =lambdap ;  
initvalue(4) =lp      ;  
initvalue(5) =wp      ;  
initvalue(6) = wi      ; 
initvalue(7) =lambdai ;  
 initvalue(8) = Y       ;
initvalue(9) = ci      ; 
 initvalue(10) = rb_ss      ;
initvalue(11) = li      ; 
 initvalue(12) = ye      ;
initvalue(13) = K       ; 
initvalue(14) = lambdae ; 
 initvalue(15) = Be      ;
initvalue(16) = ce      ; 
initvalue(17) = re      ; 
initvalue(18) = qk      ; 
initvalue(19) = phie    ; 
 initvalue(20) = x       ;
initvalue(21) = I       ; 
initvalue(22) = C       ; 
initvalue(23) = rk      ; 
initvalue(24) = Bi      ; 
initvalue(25) = spr_txj ; 
initvalue(26) = cre_pib ; 
initvalue(27) = crede   ; 
initvalue(28) = credi   ; 
initvalue(29) = Ca      ; 
initvalue(30) = Ia      ; 
initvalue(31) = phii    ; 
initvalue(32) = si      ; 
 initvalue(33) = sp      ;
initvalue(34) = credsi  ; 
initvalue(35) = Bsi     ; 
initvalue(36) = qs      ; 
initvalue(37) = S       ; 
initvalue(38) = Is      ; 
initvalue(39) = credwi  ; 
initvalue(40) = dp      ;
initvalue(41)=taue;
initvalue(42)=taui;
initvalue(43) = tausi;
initvalue(44) = b_fut; 
initvalue(45) = nu_I; 	

save init.mat initvalue;

else
 	
 endvalue = zeros(45,1);
 
endvalue(1) =cp      ;  
endvalue(2) =infl    ;  
endvalue(3) =lambdap ;  
endvalue(4) =lp      ;  
endvalue(5) =wp      ;  
endvalue(6) = wi      ; 
endvalue(7) =lambdai ;  
 endvalue(8) = Y       ;
endvalue(9) = ci      ; 
 endvalue(10) = rb_ss      ;
endvalue(11) = li      ; 
 endvalue(12) = ye      ;
endvalue(13) = K       ; 
endvalue(14) = lambdae ; 
 endvalue(15) = Be      ;
endvalue(16) = ce      ; 
endvalue(17) = re      ; 
endvalue(18) = qk      ; 
endvalue(19) = phie    ; 
 endvalue(20) = x       ;
endvalue(21) = I       ; 
endvalue(22) = C       ; 
endvalue(23) = rk      ; 
endvalue(24) = Bi      ; 
endvalue(25) = spr_txj ; 
endvalue(26) = cre_pib ; 
endvalue(27) = crede   ; 
endvalue(28) = credi   ; 
endvalue(29) = Ca      ; 
endvalue(30) = Ia      ; 
endvalue(31) = phii    ; 
endvalue(32) = si      ; 
 endvalue(33) = sp      ;
endvalue(34) = credsi  ; 
endvalue(35) = Bsi     ; 
endvalue(36) = qs      ; 
endvalue(37) = S       ; 
endvalue(38) = Is      ; 
endvalue(39) = credwi  ; 
endvalue(40) = dp      ;
endvalue(41)=taue;
endvalue(42)=taui;
endvalue(43) = tausi;
endvalue(44) = b_fut; 
endvalue(45) = nu_I; 	
    
save endv.mat endvalue;

end