% MACROECONOMICS EFFECTS OF A CREDIT DEEPENING IN LATIN AMERICA %
% C. CARVALHO, N. PASCA, L. SOUZA AND E. ZILBERMAN %
% 2016 %

    crede_model  = crede(1:35,1);
    
    taue_model  = oo_.exo_simul(1:35,1);
    
    credwi_model  = credwi(1:35,1);
    
    taui_model  = oo_.exo_simul(1:35,2);

    credsi_model  = credsi(1:35,1);
    
    tausi_model  = oo_.exo_simul(1:35,3);
    
    save fitdata crede_model taue_model credwi_model taui_model credsi_model tausi_model   

% CREDIT TO ENTREPRENEURS OVER GDP 

    clear all; close all; clc;
      

%     load creditdata
    load credfit
    load fitdata 
    
    crede_real = dados(1:35,4);
    
    diffe = crede_real - crede_model;

%while all(diffe) ~= 0 
    
    taue_new = (taue_model.*crede_real)./crede_model;

    pathe(1:34,1) = taue_new(2:35,1);
    
    load init
    
    initvalue(41,1) = taue_new(1,1); 
    
    save init.mat initvalue
    
    load endv.mat
    
    endvalue(41,1) = taue_new(35,1); 
    
    save endv.mat endvalue
    
    save pathe.mat pathe

        isInit = false;
    findSS;
    isInit = true;
    findSS;
    
    model
    
    crede_model  = crede(1:35,1);
    
    taue_model  = oo_.exo_simul(1:35,1);
    
    load credfit

    crede_real = dados(1:35,4);

    diffe = crede_real - crede_model;
    
%end;

% NON - COLLATERALIZED CREDIT TO IMPATIENT HOUSEHOLDS OVER GDP 

    clear all
    clc    

    load credfit
    load fitdata 
    
    credwi_real = dados(1:35,2);

    diffwi = credwi_real - credwi_model;

%while all(diffwi) ~= 0 
    
    taui_new = (taui_model.*credwi_real)./credwi_model;

    pathwi(1:34,1) = taui_new(2:35,1);
    
    load init
    
    initvalue(42,1) = taui_new(1,1); 
    
    save init.mat initvalue
    
    load endv.mat
    
    endvalue(42,1) = taui_new(35,1); 
    
    save endv.mat endvalue
    
    save pathwi.mat pathwi

        isInit = false;
    findSS;
    isInit = true;
    findSS;
    
    model
    
    credwi_model  = credwi(1:35,1);
    
    taui_model  = oo_.exo_simul(1:35,2);
    
    load credfit

    credwi_real = dados(1:35,2);

    diffwi = credwi_real - credwi_model;
    
%end;

% COLLATERALIZED CREDIT TO IMPATIENT HOUSEHOLDS OVER GDP 

    clear all
    clc    

    load credfit
    load fitdata 
    
    credsi_real = dados(1:35,3);

    diffsi = credsi_real - credsi_model;

%while all(diffsi) ~= 0 
    
    tausi_new = (tausi_model.*credsi_real)./credsi_model;

    pathsi(1:34,1) = tausi_new(2:35,1);
    
    load init
    
    initvalue(43,1) = tausi_new(1,1); 
    
    save init.mat initvalue
    
    load endv.mat
    
    endvalue(43,1) = tausi_new(35,1); 
    
    save endv.mat endvalue
    
    save pathsi.mat pathsi

    isInit = false;
    findSS;
    isInit = true;
    findSS;
    
    model
    
    credsi_model  = credsi(1:35,1);
    
    tausi_model  = oo_.exo_simul(1:35,3);
    
    load credfit

    credsi_real = dados(1:35,3);

    diffsi = credsi_real - credsi_model;
    
%end;
