% MACROECONOMICS EFFECTS OF A CREDIT DEEPENING IN LATIN AMERICA %
% C. CARVALHO, N. PASCA, L. SOUZA AND E. ZILBERMAN %
% 2018 %


% ADD THE PATH WHERE IS DYNARE IS LOCATED 
addpath c:\dynare\4.5.6\matlab

clc; clear all; close all;

% PARAMETERS:
% pp, pe and pi are weights of the agents, set to one in the final version,
% whose notation were omitted in the final version of the paper 

    sigma    = 0.8;             % 1
    sig      = 1.0000;          % 2
    bettap   = 0.9834;          % 3
    bettae   = 0.96;            % 4
    bettai   = 0.96;            % 5
    phi      = 1.0000;          % 6
    gamma    = 0.44;            % 7
    theta    = 0.708;             % 8
    delta    = 0.025;           % 9
    kappai   = 2.53;            % 10
    kappa_pi = 2.4300;          % 11
    kappa_y  = 0.1600;          % 12
    infl_ss  = 1.01342;         % 13
    phip     = 0.1580;          % 14
    rho_rb   = 0.7900;          % 15
    epsilony = 6.0000;          % 16
    epsl     = 3.0000;          % 17
    ind_w    = 0.3001;          % 18
    kappap   = 50;              % 19
    deltas   = 0.025;           % 20
    kappasi  = 2.53;            % 21
    pp       = 1;               % 22
    pe       = 1;               % 23
    pi       = 1;               % 24
    etae     = 0.00633;          % 25
    gammae   = 2;               % 26
    
    % .*.*.*.* Benchmark - Next period income

    chi_b = 1; chi_wl = 0; chi_Fb = 0; chi_Fwl = 1;

    % .*.*.*.* Proxy for future income:

    % chi = 0.95; ././ Max possible: 0.97 Pref choice: 0.95
    % chi_b = 1; chi_wl = 0; chi_Fb = chi; chi_Fwl = (1-chi);

    % .*.*.*.* Current income:

    % chi_b = 0; chi_wl = 1; chi_Fb = 0; chi_Fwl = 1;

    
    % .*.*.*.* Turning on/off the collaterals    
   
    % if = 1, collateral feedbacks; if = 0 exogenous limit
    % taui_aux - wages; tausi_aux - durables; taue_aux - capital
    
    taui_aux = 1; tausi_aux = 1; taue_aux = 1;

    param = [sigma sig bettap bettae bettai phi gamma theta delta kappai kappa_pi kappa_y infl_ss phip rho_rb epsilony epsl ind_w kappap deltas kappasi pp pe pi etae gammae chi_b chi_wl chi_Fb chi_Fwl taui_aux tausi_aux taue_aux]';
    save('param.mat', 'param')
    
    isInit = false;
    findSS;
    isInit = true;
    findSS;
    
    dynare model.mod
    
        
% FITTING PATHS:
% CHANGE PARAMETERS? 1 - YES, 0 - NO 

    changeparam = 0;

 if changeparam == 1
    fitpaths
 end;
 
% CREDIT CONSTRAINTS MULTIPLIERS:
   
     creditconstraints
 
% SAVING RESULTS     
    
    clear ans
    clear Simulated*
    clear h

    save benchmark 