% MACROECONOMICS EFFECTS OF A CREDIT DEEPENING %
% C. CARVALHO, N. PASCA, L. SOUZA AND E. ZILBERMAN %
% PUC - RIO, 2014 %

load creditdata2.mat

years = [2004; 2004; 2004; 2004; 2005; 2005; 2005; 2005;...
        2006; 2006; 2006; 2006; 2007; 2007; 2007; 2007;...
        2008; 2008; 2008; 2008; 2009; 2009; 2009; 2009;...
        2010; 2010; 2010; 2010; 2011; 2011; 2011; 2011;...
        2012; 2012; 2012];
    
months = [3 6 9 12 3 6 9 12 3 6 9 12 3 6 9 12 3 6 9 12 3 6 9 12 3 6 9 12 3 6 9 12 3 6 9];

days = ones(1,35);

for k = 1:35
    
   dates(k) = datenum(years(k), months(k), days(k));
        
end;

for i = 1:35
    x(i,1) = i;
end;

p1 = polyfit(x,dados(:,2),3);
f1 = polyval(p1,x);

p2 = polyfit(x,dados(:,3),3);
f2 = polyval(p2,x);

p3 = polyfit(x,dados(:,4),3);
f3 = polyval(p3,x);

f33 = f3;

for i = 32:35
    f33(i,1) = f3(31,1);
end;    

figure(1)

subplot(1,3,1);

plot(dates,100*dados(:,2),'-k','LineWidth',2, 'MarkerSize',3,'Marker','*'); 
grid on
hold on 
plot(dates,100*f1,'-r','LineWidth',2); 
h = legend('Real','Fit');
labels = datestr(dates,12);
set(gca,'XTickLabel',{'Mar04','Mar05','Mar06','Mar07','Mar08','Mar09','Mar10','Mar11','Mar12'},...
    'XTick',[732007 732372 732737 733102 733468 733833 734198 734563 734929]);
xlim([732007 735113])
title('Non-collateralized Credit to impatient households over GDP(%)');

subplot(1,3,2);
plot(dates,100*dados(:,3),'-k','LineWidth',2, 'MarkerSize',3,'Marker','*'); 
grid on
hold on 
plot(dates,100*f2(1:35),'-r','LineWidth',2); 
labels = datestr(dates,12);
set(gca,'XTickLabel',{'Mar04','Mar05','Mar06','Mar07','Mar08','Mar09','Mar10','Mar11','Mar12'},...
    'XTick',[732007 732372 732737 733102 733468 733833 734198 734563 734929]);
xlim([732007 735113])
title('Collateralized Credit to impatient households over GDP (%)');

subplot(1,3,3);
plot(dates,100*dados(:,4),'-k','LineWidth',2, 'MarkerSize',3,'Marker','*'); 
grid on
hold on 
plot(dates,100*f3,'-r','LineWidth',2); 
hold on 
plot(dates,100*f33,'-b','LineWidth',2); 
labels = datestr(dates,12);
set(gca,'XTickLabel',{'Mar04','Mar05','Mar06','Mar07','Mar08','Mar09','Mar10','Mar11','Mar12'},...
    'XTick',[732007 732372 732737 733102 733468 733833 734198 734563 734929]);
xlim([732007 735113])
title('Credit to entrepreneurs over GDP (%)');



